package daba.db;

import java.io.Serializable;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.MapsId;
import javax.persistence.OneToOne;
import javax.persistence.Table;

@Entity
@Table(name = "AISAdministrator")
public class Administrator implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    private Long ID;
    
    @OneToOne(cascade = CascadeType.ALL) @MapsId("ID")
    private Person person;
    
    private String POSITION;
     
    public Person getPerson()
    {
        return person;
    }
    
    public static Administrator newAdministrator(String firstname, 
                                                 String lastname, 
                                                 long yearStarted,
                                                 String position)
    {
        Administrator newad = new Administrator();
        newad.person = Person.newPerson(firstname, lastname, yearStarted);
        newad.POSITION = position;
        return newad;
    }
    
    public Long getId() {
        return ID;
    }

    public void setId(Long id) {
        this.ID = id;
    }

    public String getPosition()
    {
        return POSITION;
    }
    
    public void setDepartment(String position)
    {
        POSITION = position;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (ID != null ? ID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Administrator)) {
            return false;
        }
        Administrator other = (Administrator) object;
        if ((this.ID == null && other.ID != null) || (this.ID != null && !this.ID.equals(other.ID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "daba.Administrator[ id=" + ID + " ]";
    }
    
}
